/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_PRINTER_H_
#define __GDAM_PRINTER_H_

#include <stdio.h>
#include <glib.h>

typedef struct _GdamPrinter GdamPrinter;

GdamPrinter*   gdam_printer_new(FILE* out);
void           gdam_printer_indent(GdamPrinter*);
void           gdam_printer_unindent(GdamPrinter*);
void           gdam_printer_write_line(GdamPrinter*,
                                       const char* fmt,
				       ...) G_GNUC_PRINTF(2,3);
void           gdam_printer_destroy(GdamPrinter*);
void           gdam_printer_destroy_without_fclose(GdamPrinter*);

#endif
