/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __MODEL_FILTER_GAIN_H_
#define __MODEL_FILTER_GAIN_H_

#include <gdam/client/gdamchannel.h>
#include "gdamfilter.h"
#include "gdaminfomanager.h"

typedef struct _GdamGain GdamGain;
typedef struct _GdamGainClass GdamGainClass;

GtkType gdam_gain_get_type();
#define GDAM_TYPE_GAIN			(gdam_gain_get_type ())
#define GDAM_GAIN(obj)			(GTK_CHECK_CAST ((obj), GDAM_TYPE_GAIN, GdamGain))
#define GDAM_GAIN_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_GAIN, GdamGainClass))
#define GDAM_IS_GAIN(obj)		(GTK_CHECK_TYPE ((obj), GDAM_TYPE_GAIN))
#define GDAM_IS_GAIN_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_GAIN))

struct _GdamGainClass {
	GdamFilterClass		filter_class;
	void			(*update_volume) 	(GdamGain*	gain,
							 gdouble	volume);
	void                    (*update_muted)         (GdamGain*      gain,
	                                                 gboolean       muted);
};

struct _GdamGain {
	GdamFilter		filter;
	guint 			gain_id;
    	float 			volume;
	gboolean		muted;
	gboolean		soloed;
};

void		gdam_gain_set_volume	(GdamGain*		gain,
					 gdouble 		newvol);
void		gdam_gain_set_muted	(GdamGain*		gain,
					 gboolean               muting);

#endif
