/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
/*
 * A user-database mechanism.
 *
 * Entries are stored in
 *     ~/.gdam/category
 *
 * With lines like:
 *     entry1: value1
 *     entry2: value2
 *
 * a simple mechanism to save state between sessions
 * which isn't really important or sensitive 
 * (b/c the files probably have the user's umask)
 */

#ifndef __GDAM_HISTORY_H_
#define __GDAM_HISTORY_H_

const char*   gdam_history_get_entry     (const char*     category,
                                          const char*     entry);
void          gdam_history_set_entry     (const char*     category,
                                          const char*     entry,
					  const char*     value);

/* Creates ~/.gdam/ as appropriate (if possible) */
void          initialize_root_gdam_directory ();

/* Returns ~/.gdam/ or similar, NULL if none exists. */
const char   *gdam_get_user_dir ();

#endif
