/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_REQUEST_BUILDER_H_
#define __GDAM_REQUEST_BUILDER_H_

typedef struct _GdamRequestBuilder GdamRequestBuilder;

#include <gdam/client/gdamrequest.h>

/* Describes the requests being used to build the source... */
struct _GdamRequestBuilder {
	GSList*			first_request;
	GSList*			last_request;
};

GdamRequestBuilder* gdam_request_builder_new    ();
int                 gdam_request_builder_append_create
                                                (GdamRequestBuilder* builder,
                                                 GdamRequest*        request);
void                gdam_request_builder_append_generic
                                                (GdamRequestBuilder* builder,
                                                 GdamRequest*        request);

/* Will return NULL if there are no requests. */
GdamRequest*        gdam_request_builder_package(GdamRequestBuilder* builder);

void                gdam_request_builder_destroy(GdamRequestBuilder* builder);


#endif
