/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_PERMISSIONS_H_
#define __GDAM_PERMISSIONS_H_

typedef struct _GdamPermissions GdamPermissions;
/*
 * This is a user's authorization.
 */
struct _GdamPermissions {
	unsigned	may_create_source : 1,
			may_open_device : 1,
			may_affect_others : 1;

	/* -1 means "no user id"
	 *  0 means "superuser"
	 *  otherwise just a user id... */
	int		user_id;
};

/* Give the user no rights. */
void gdam_permissions_none(GdamPermissions  *to_clear);

/* Give the user super-user rights. */
void gdam_permissions_root(GdamPermissions  *to_set);

#endif
