/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_WALKER_H_
#define __GDAS_WALKER_H_

typedef struct _GdasWalker GdasWalker;

#include "gdassource.h"
#include "gdamcachebuffer.h"

GtkType gdas_walker_get_type ();
#define GDAS_TYPE_WALKER              (gdas_walker_get_type ())
#define GDAS_WALKER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_WALKER, GdasWalker))

struct _GdasWalker {
	GdasSource		source;
	GdamCacheBuffer*	cache;

	unsigned short int	random_state[3];
	int			direction;
	int			length;
	int			mean_length;
	int			position;

	gboolean		beat_mode;
	gboolean		sync_mode;
	double			t_first_beat;
	double			bpm;
	double			sync_likelihood;
	double			forward_likelihood;
	GPtrArray              *constraints;

	gint64			t_samples;
};

GdasWalker        *gdas_walker_new              (guint            buffer_id);


#endif
